package com.test;

import static org.junit.Assert.assertTrue;

import java.util.Date;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import com.google.appengine.api.datastore.Query.FilterOperator;
import com.google.appengine.tools.development.testing.LocalDatastoreServiceTestConfig;
import com.google.appengine.tools.development.testing.LocalServiceTestHelper;
import com.google.code.twig.ObjectDatastore;
import com.google.code.twig.annotation.AnnotationObjectDatastore;
import com.test.model.Band;
import com.test.model.Concert;
import com.test.model.CurrencyAmount;
import com.test.model.CurrencyAmount.CurrencyType;
import com.test.model.Fan;
import com.test.model.dao.FanDao;

public class ActivationBugTest {

    private final LocalServiceTestHelper helper = new LocalServiceTestHelper(
            new LocalDatastoreServiceTestConfig());

    @Before
    public void setupDatastore() {
        helper.setUp();
    }

    @After
    public void tearDownDatastore() {
        helper.tearDown();
    }

    @Test
    public void testAssociation() {
        ObjectDatastore datastore = new AnnotationObjectDatastore(false);
        Fan fan = new Fan();
        fan.setName("Me");
        Concert concert = new Concert(new Date(), new CurrencyAmount(
                CurrencyType.CHF, 25.0));
        Band britney = new Band("Britney", new CurrencyAmount(CurrencyType.CHF,
                25.0));
        concert.getBands().add(britney);
        fan.getConcerts().add(concert);
        // FanDao fanDao = new FanDao();
        // fanDao.create(fan);

        datastore.store(fan);

        // fanDao = new FanDao();
        // Fan datastoreFan = fanDao.readById(fan.getId(), 0);
        // System.out.println(datastoreFan.getName());
        // System.out.println(datastoreFan.getConcerts().size());
        // fanDao.activate(datastoreFan);
        // System.out.println(datastoreFan.getConcerts().get(0).getId());
        // System.out.println(datastoreFan.getConcerts().get(0).getPrice());
        // fanDao.active1(datastoreFan.getConcerts().get(0));
        // System.out.println(datastoreFan.getConcerts().get(0).getId());
        // System.out.println(datastoreFan.getConcerts().get(0).getPrice());
        // fanDao.activeAll(datastoreFan.getConcerts());
        // System.out.println(datastoreFan.getConcerts().get(0).getId());
        // System.out.println(datastoreFan.getConcerts().get(0).getPrice());

        datastore = new AnnotationObjectDatastore(false);
        Fan datastoreFan = datastore.find().type(Fan.class).activate(0).addFilter(
                "id", FilterOperator.EQUAL, fan.getId()).returnUnique().now();
        assertTrue(datastoreFan.getName().equals("Me"));
        assertTrue(datastoreFan.getConcerts().size() == 1);
        assertTrue(datastoreFan.getConcerts().get(0).getId() != null);
        assertTrue(datastoreFan.getConcerts().get(0).getPrice() == null);
        // datastore.activate(datastoreFan.getConcerts());
        // datastore.activateAll(datastoreFan.getConcerts());
        // assertTrue(datastoreFan.getConcerts().get(0).getPrice() != null);
        datastore.activate(datastoreFan.getConcerts().get(0));
        assertTrue(datastoreFan.getConcerts().get(0).getPrice() != null);

    }

    // @Test
    public void testConcurrency() throws InstantiationException,
            IllegalAccessException {
        // ObjectDatastore datastore = new AnnotationObjectDatastore(false);
        // Create a Fan
        Fan fan = Fan.class.newInstance();
        fan.setName("Me");
        FanDao fanDao = new FanDao();
        fanDao.create(fan);

        // Get a Fan to add a concert
        fanDao = new FanDao();
        fan = fanDao.readById(fan.getId(), 0);
        fanDao = new FanDao();
        Concert concert = new Concert(new Date(), new CurrencyAmount(
                CurrencyType.CHF, 25.0));
        Band britney = new Band("Britney", new CurrencyAmount(CurrencyType.CHF,
                25.0));
        concert.getBands().add(britney);
        fan.getConcerts().add(concert);
        fanDao.associate(fan);
        fanDao.activate(fan);
        fanDao.update(fan);

        //
        // List<Concert> concerts =
        // datastore.find().type(Concert.class).returnAll().now();
        // System.out.println(concerts.size());
    }
}
