package com.test.model;

import java.util.Collection;
import java.util.List;

import com.google.appengine.api.datastore.Key;
import com.google.code.twig.ObjectDatastore;

public class MyDao<T extends DatastoreObject> {

    protected ObjectDatastore datastore;

    // protected MyDao(ObjectDatastore datastore) {
    // this.datastore = datastore;
    // }

    public Key create(T entity) {
        // datastore = new AnnotationObjectDatastore(false);
        increaseVersion(entity);
        return datastore.store(entity);
    }

    public void update(T entity) {
        // datastore = new AnnotationObjectDatastore(false);
        increaseVersion(entity);
        datastore.update(entity);
    }

    public void updateChild(List< ? extends DatastoreObject> children) {
        // datastore = new AnnotationObjectDatastore(false);
        for (DatastoreObject child : children) {
            increaseVersion(child);
            if (!datastore.isAssociated(child)) {
                datastore.associate(child);
            }
            datastore.update(child);
        }
    }

    private void increaseVersion(DatastoreObject entity) {
        entity.setVersion(entity.getVersion() + 1);
    }

    public void updateWithChild(T entity,
            List< ? extends DatastoreObject> children) {
        // datastore = new AnnotationObjectDatastore(false);
        increaseVersion(entity);
        datastore.update(entity);
        for (DatastoreObject child : children) {
            increaseVersion(child);
            if (!datastore.isAssociated(child)) {
                datastore.associate(child);
            }
            datastore.update(child);
        }
    }

    public void associate(T entity) {
        // datastore = new AnnotationObjectDatastore(false);
        datastore.associate(entity);
    }

    public void activate(T entity) {
        datastore.activate(entity);
    }

    public void active1(Object entity) {
        datastore.activate(entity);
    }

    public void activeAll(Collection< ? > entity) {
        datastore.activateAll(entity);
    }

}
